;;;Bosse-engineering                                                                                       
;;;Dipl.-Ing. Jrn Bosse                                                                                   
;;;Am Klei 5	                                                                                           
;;;384458 Velpke                                                                                           
;;;Tel. 05361 / 989 677                                                                                    
;;;mobil. 0176 / 232 828 51                                                                                
;;;bosse@bosse-engineering.com                                                                             
;;;                                                                                                        
;;;--------------------------------------------------------------------------------------------------------
;;;WorkShop "LISP-Programmierung" 18.11.09								   
;;;--------------------------------------------------------------------------------------------------------

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Hauptfunktion TextManipulate1 => 1. Beispiel: Text manipulieren		   
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

(defun c:TextManipulate1 ( / AWS N TEXTWERT textwert_liste)
  (if (setq aws (ssget (list '(0 . "TEXT")'(8 . "RWA-SCA-SNR"))))
    (progn
      (setq n 0)
      (repeat (sslength aws)
        ;;;Textteil "R" gegen "RWA" tauschen
        (setq textwert (cdr(assoc 1(entget (ssname aws n))))
              textwert (if(not(vl-string-search "RWA" textwert))
                         (vl-string-subst "RWA" "R" textwert)
                         textwert))
        ;;;Textteil ".#." per Adition um einen zu erhhen
        (if(and
             (setq textwert_liste (JBf_WorkShop:String->List textwert "."))
             (=(length textwert_liste)3))
        (setq textwert_liste (subst(itoa(+(atoi (nth 2 textwert_liste))100))(nth 2 textwert_liste)textwert_liste)
              textwert (JBf_WorkShop:List->String 'T textwert_liste ".")))
        (entmod(subst (cons 1 textwert)(assoc 1 (entget(ssname aws n)))(entget(ssname aws n))))
        (setq n (+ n 1))))
      (alert "\nEs wurden keine gltigen Texte ausgewhlt."))
  (princ))



;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Hauptfunktion TextManipulate1 => 2. Beispiel: Text manipulieren		   
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

(defun c:TextManipulate2 ( / AWS N TEXTWERT)
  (if (setq aws (ssget (list '(0 . "TEXT")'(8 . "RWA-SCA-HOE"))))
    (progn
      (setq n 0)
      (repeat (sslength aws)
        ;;;Textteil "  " gegen "=" tauschen
        (setq textwert (cdr(assoc 1(entget (ssname aws n))))
              textwert (if(not(vl-string-search "=" textwert))
                         (vl-string-subst "=" "  " textwert)
                         textwert))
        ;;;Deckelhhen +1.00, Tiefen +1.00
        (if (member (substr textwert 1 1)'("D" "T"))
                     (setq textwert
                            (strcat
                              (substr textwert 1 (+(vl-string-search "=" textwert)1))
                              (rtos(+(atof(substr textwert (+(vl-string-search "=" textwert)2)))1.0)2 2))))
        
        (entmod(subst (cons 1 textwert)(assoc 1 (entget(ssname aws n)))(entget(ssname aws n))))
        (setq n (+ n 1))))
      (alert "\nEs wurden keine gltigen Texte ausgewhlt."))
  (princ))
                                  

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Funktion JBf_WorkShop:String->List => String in Liste, Trennung per Zeichen     
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;;;-> string: Stringelement
;;;-> trennzeichen: Trennzeichen als String
;;;<- Liste, mit einzelnen Stringelementen

(defun JBf_WorkShop:String->List (string trennzeichen / LISTE)
  (if (vl-string-search trennzeichen string)
    (progn
      (while (vl-string-search trennzeichen string)
        (setq liste (cons (substr string 1 (vl-string-search trennzeichen string))liste)
              string (substr string(+(vl-string-search trennzeichen string)(+ (strlen trennzeichen)1)))))
      (setq liste (cons string liste))))
    (reverse liste))

;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
;;;Funktion JBf_string_list_trenzeichen->string => Liste zu String mit Trennzeichen
;;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

;;;-> liste: Liste, deren Elemente in String zusammengefasst werden soll
;;;-> trennzeichen: Trennzeichen fr einzelen Listenelemente
;;;-> flag: wenn 'T, dann letztes Trennzeichen entfernen
;;;<- String, zusammengesetzt aus Listenelementen
  
(defun JBf_WorkShop:List->String(flag liste trennzeichen / string)
  (setq string "")
  (mapcar '(lambda(A)
             (setq string (strcat string A trennzeichen)))liste)
  (if flag
    (vl-string-right-trim trennzeichen string)
    string))
  
